﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using HeuristicLab.Core;
using HeuristicLab.Optimization;
using HeuristicLab.Problems.DataAnalysis;

namespace HeuristicLab.Algorithms.DataAnalysis {
  internal class M5UpdateParameters {
    private readonly ILeafType<IRegressionModel> LeafType1;
    private readonly IRegressionProblemData ProblemData1;
    private readonly IRandom Random1;
    private readonly ResultCollection Results1;
    public ILeafType<IRegressionModel> LeafType {
      get { return LeafType1; }
    }
    private IRegressionProblemData ProblemData {
      get { return ProblemData1; }
    }
    public IRandom Random {
      get { return Random1; }
    }
    public ResultCollection Results {
      get { return Results1; }
    }

    public IEnumerable<string> AllowedInputVariables {
      get { return ProblemData.AllowedInputVariables; }
    }
    public string TargetVariable {
      get { return ProblemData.TargetVariable; }
    }
    public IDataset Data {
      get { return ProblemData.Dataset; }
    }

    public M5UpdateParameters(ILeafType<IRegressionModel> modeltype, IRegressionProblemData problemData, IRandom random, ResultCollection results) {
      ProblemData1 = problemData;
      Random1 = random;
      LeafType1 = modeltype;
      Results1 = results;
    }
  }
}